// generated by: arc -uNMLP -o list.c -H list.h -m list.argl.tmp list.arg 
#include "list.h"

/** :argrt_list_new <any data> <function delete>: -> list **/
#line 78 "list.arg"
argrt_list_t * argrt_list_new(void * data, void (* delete)())
{
#line 79 "list.arg"
  argrt_list_t * x = ((argrt_list_t *)0);

#line 79 "list.arg"
  x = ((argrt_list_t *)memset(ARGRT_malloc(sizeof(argrt_list_t)), 0, sizeof(argrt_list_t)));
  (x)->next = ((argrt_list_t *)0);
  (x)->prev = ((argrt_list_t *)0);
  (x)->data.any = data;
  (x)->del = ((void (*)(void *))delete);
  return ((argrt_list_t *)x);
}

/** :argrt_list_from_vargs <function (any) del> <any data> [...]: -> list **/
#line 86 "list.arg"
argrt_list_t * argrt_list_from_vargs(void (* del)(void *), void * data_2, ...)
{
  argrt_list_t * first;
  argrt_list_t * prev;
  va_list va;

#line 87 "list.arg"
  if ((data_2 == NULL)) {
#line 579 "./std.argl"
    return ((argrt_list_t *)0);
  }
#line 88 "list.arg"
  first = argrt_list_new(data_2, del);
  prev = first;
#line 91 "list.arg"
  va_start(va, data_2);
  data_2 = va_arg(va, void *);
  while (!((data_2 == NULL))) {
    argrt_list_t * curr;

#line 94 "list.arg"
    curr = argrt_list_new(data_2, del);
    argrt_list_append(&prev, curr);
    data_2 = va_arg(va, void *);
  };
#line 97 "list.arg"
  va_end(va);
  return first;
}

/** :argrt_list_from_array <array a> <nat n> (<function (any) d>): -> list **/
#line 100 "list.arg"
argrt_list_t * argrt_list_from_array(void *(* a), unsigned int n, void (* d)(void *), ...)
{
#line 101 "list.arg"
  argrt_list_t * first = ((argrt_list_t *)0);
#line 101 "list.arg"
  argrt_list_t * previous = ((argrt_list_t *)0);

#line 102 "list.arg"
  while (((n)-- > 0)) {
    argrt_list_t * current;

#line 103 "list.arg"
    current = argrt_list_new((a)[0], d);
    if ((first == ((argrt_list_t *)0))) {
      first = current;
    }
#line 106 "list.arg"
    else {
      argrt_list_link(previous, current);
    }
#line 108 "list.arg"
    previous = current;
    a = (a + 1);
  };
#line 110 "list.arg"
  return first;
}

/** :argrt_list_delete_all <list>: -> nothing **/
#line 113 "list.arg"
void argrt_list_delete_all(argrt_list_t * p_list_of)
{
#line 114 "list.arg"
  argrt_list_t * cur;
#line 114 "list.arg"
  argrt_list_t * prev;
#line 114 "list.arg"
  argrt_list_t * next;

#line 115 "list.arg"
  prev = (((p_list_of != ((argrt_list_t *)0))) ? (((argrt_list_t *)p_list_of)->prev) : (((argrt_list_t *)0)));
  cur = p_list_of;
  while ((cur != ((argrt_list_t *)0))) {
    next = ((argrt_list_t *)cur)->next;
    argrt_list_delete_single(cur);
    cur = next;
  };
#line 121 "list.arg"
  cur = prev;
  while ((cur != ((argrt_list_t *)0))) {
    prev = ((argrt_list_t *)cur)->prev;
    argrt_list_delete_single(cur);
    cur = prev;
  };
}

/** :argrt_list_delete_single <list>: -> nothing **/
#line 128 "list.arg"
void argrt_list_delete_single(argrt_list_t * p_list_of_2)
{
#line 129 "list.arg"
  if (!((((argrt_list_t *)p_list_of_2)->del == ((void (*)(void *))0)))) {
    (*((argrt_list_t *)p_list_of_2)->del)(*((void * *)&((argrt_list_t *)p_list_of_2)->data.any));
  }
#line 131 "list.arg"
  ARGRT_free(p_list_of_2);
}

/** :argrt_list_remove <(list) & head> <list elem>: -> nothing **/
void argrt_list_remove(argrt_list_t * * head, argrt_list_t * elem)
{
#line 136 "list.arg"
  if ((elem == ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    return;
  }
#line 137 "list.arg"
  if ((*head == elem)) {
    *head = ((argrt_list_t *)elem)->next;
  }
#line 139 "list.arg"
  argrt_list_link(((argrt_list_t *)elem)->prev, ((argrt_list_t *)elem)->next);
  ((argrt_list_t *)elem)->prev = ((argrt_list_t *)0);
  ((argrt_list_t *)elem)->next = ((argrt_list_t *)0);
}

/** :argrt_list_link <list a> <list b>: -> nothing **/
#line 144 "list.arg"
void argrt_list_link(argrt_list_t * a_2, argrt_list_t * b)
{
#line 145 "list.arg"
  if ((a_2 != ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    ((argrt_list_t *)a_2)->next = b;
  }
#line 146 "list.arg"
  if ((b != ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    ((argrt_list_t *)b)->prev = a_2;
  }
}

/** :argrt_list_unlink <list a> <list b>: -> nothing **/
#line 149 "list.arg"
void argrt_list_unlink(argrt_list_t * a_3, argrt_list_t * b_2)
{
#line 150 "list.arg"
  if ((a_3 != ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    ((argrt_list_t *)a_3)->next = ((argrt_list_t *)0);
  }
#line 151 "list.arg"
  if ((b_2 != ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    ((argrt_list_t *)b_2)->prev = ((argrt_list_t *)0);
  }
}

/** :argrt_list_chain <list first> [...]: -> list **/
#line 155 "list.arg"
argrt_list_t * argrt_list_chain(argrt_list_t * first, ...)
{
  argrt_list_t * prev;
  va_list va;
#line 160 "list.arg"
  argrt_list_t * curr;

#line 156 "list.arg"
  if ((first == ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    return ((argrt_list_t *)0);
  }
#line 157 "list.arg"
  prev = first;
#line 159 "list.arg"
  va_start(va, first);
  curr = va_arg(va, argrt_list_t *);
  while (!((curr == ((argrt_list_t *)0)))) {
    argrt_list_append(&prev, curr);
    curr = va_arg(va, argrt_list_t *);
  };
#line 164 "list.arg"
  va_end(va);
  return first;
}

/** :argrt_list_append <(list) & tail> <list x>: -> nothing **/
void argrt_list_append(argrt_list_t * * tail, argrt_list_t * x)
{
#line 170 "list.arg"
  argrt_list_link(*tail, x);
  if ((x != ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    *tail = x;
  }
}

/** :argrt_list_prepend <(list) & head> <list x>: -> nothing **/
#line 175 "list.arg"
void argrt_list_prepend(argrt_list_t * * head_2, argrt_list_t * x_2)
{
#line 176 "list.arg"
  argrt_list_link(x_2, *head_2);
  if ((x_2 != ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    *head_2 = x_2;
  }
}

/** :argrt_list_push_back <(list) & head> <list>: -> nothing **/
#line 182 "list.arg"
void argrt_list_push_back(argrt_list_t * * head_3, argrt_list_t * p_list_of_3)
{
#line 183 "list.arg"
  if ((*head_3 == ((argrt_list_t *)0))) {
    argrt_list_link(((argrt_list_t *)0), p_list_of_3);
    *head_3 = p_list_of_3;
  } else {
    argrt_list_link(argrt_list_end(*head_3), p_list_of_3);
  }
}

/** :argrt_list_pop <(list) & list>: -> list **/
#line 190 "list.arg"
argrt_list_t * argrt_list_pop(argrt_list_t * * list)
{
#line 191 "list.arg"
  argrt_list_t * top;

#line 191 "list.arg"
  top = *list;
  if (!((top == ((argrt_list_t *)0)))) {
    *list = ((argrt_list_t *)top)->next;
    if (!((*list == ((argrt_list_t *)0)))) {
      ((argrt_list_t *)((argrt_list_t *)top)->next)->prev = ((argrt_list_t *)0);
    }
#line 196 "list.arg"
    ((argrt_list_t *)top)->next = ((argrt_list_t *)0);
  }
#line 197 "list.arg"
  return top;
}

/** :argrt_list_postinsert <list> <list to>: -> nothing **/
#line 200 "list.arg"
void argrt_list_postinsert(argrt_list_t * p_list_of_4, argrt_list_t * to)
{
#line 201 "list.arg"
  argrt_list_link(p_list_of_4, ((argrt_list_t *)to)->next);
  argrt_list_link(to, p_list_of_4);
}

/** :argrt_list_preinsert <list> <list to>: -> nothing **/
#line 205 "list.arg"
void argrt_list_preinsert(argrt_list_t * p_list_of_5, argrt_list_t * to_2)
{
#line 206 "list.arg"
  argrt_list_link(((argrt_list_t *)to_2)->prev, p_list_of_5);
  argrt_list_link(p_list_of_5, to_2);
}

/** :argrt_list_swap_data <list a> <list b>: -> nothing **/
#line 210 "list.arg"
void argrt_list_swap_data(argrt_list_t * a_4, argrt_list_t * b_3)
{
#line 211 "list.arg"
  void * tmp = NULL;
#line 214 "list.arg"
  void (* tmp_2)(void *);

#line 211 "list.arg"
  tmp = *((void * *)&((argrt_list_t *)a_4)->data.any);
  *((void * *)&((argrt_list_t *)a_4)->data.any) = *((void * *)&((argrt_list_t *)b_3)->data.any);
  *((void * *)&((argrt_list_t *)b_3)->data.any) = tmp;
  tmp_2 = ((argrt_list_t *)a_4)->del;
  ((argrt_list_t *)a_4)->del = ((argrt_list_t *)b_3)->del;
  ((argrt_list_t *)b_3)->del = tmp_2;
}

/** :argrt_list_reverse <(list) & head>: -> nothing **/
#line 219 "list.arg"
void argrt_list_reverse(argrt_list_t * * head_4)
{
#line 220 "list.arg"
  argrt_list_t * list_2;

#line 220 "list.arg"
  list_2 = *head_4;
  while (!((list_2 == ((argrt_list_t *)0)))) {
    argrt_list_t * next;

#line 222 "list.arg"
    next = ((argrt_list_t *)list_2)->next;
    ((argrt_list_t *)list_2)->next = ((argrt_list_t *)list_2)->prev;
    ((argrt_list_t *)list_2)->prev = next;
    if ((next == ((argrt_list_t *)0))) {
      *head_4 = list_2;
      return;
    }
#line 228 "list.arg"
    list_2 = next;
  };
}

/** :argrt_list_sort <list> <function (any) (any) - \> (int) cmp>: -> nothing **/
#line 231 "list.arg"
void argrt_list_sort(argrt_list_t * p_list_of_6, int (* cmp)(void *, void *))
{
  unsigned char loop;

#line 232 "list.arg"
  if ((cmp == ((int (*)(void *, void *))0))) {
#line 579 "./std.argl"
    return;
  }
#line 233 "list.arg"
  loop = 1;
  while (loop) {
#line 236 "list.arg"
    argrt_list_t * cur;

#line 235 "list.arg"
    loop = 0;
    cur = p_list_of_6;
    while ((cur != ((argrt_list_t *)0))) {
      argrt_list_t * next;

#line 238 "list.arg"
      next = ((argrt_list_t *)cur)->next;
      if ((next == ((argrt_list_t *)0))) {
#line 579 "./std.argl"
        break;
      }
#line 240 "list.arg"
      if (((*cmp)(*((void * *)&((argrt_list_t *)cur)->data.any), *((void * *)&((argrt_list_t *)next)->data.any)) < 0)) {
        argrt_list_swap_data(cur, next);
        loop = 1;
      }
#line 243 "list.arg"
      cur = next;
    };
  };
}

/** :argrt_list_search <list> <any ref> <function (any) (any) - \> (int) eq>: -> list **/
#line 247 "list.arg"
argrt_list_t * argrt_list_search(argrt_list_t * p_list_of_7, void * ref, int (* eq)(void *, void *))
{
#line 248 "list.arg"
  argrt_list_t * cur;

#line 249 "list.arg"
  if ((eq == ((int (*)(void *, void *))0))) {
    for (cur = p_list_of_7; (cur); cur = ((argrt_list_t *)cur)->next) {
      if ((*((void * *)&((argrt_list_t *)cur)->data.any) == ref)) {
        return cur;
      }
    };
  } else {
#line 254 "list.arg"
    for (cur = p_list_of_7; (cur); cur = ((argrt_list_t *)cur)->next) {
      if (((*eq)(*((void * *)&((argrt_list_t *)cur)->data.any), ref))) {
        return cur;
      }
    };
  }
#line 257 "list.arg"
  return ((argrt_list_t *)0);
}

/** :argrt_list_start <list>: -> list **/
#line 260 "list.arg"
argrt_list_t * argrt_list_start(argrt_list_t * p_list_of_8)
{
#line 261 "list.arg"
  if ((p_list_of_8 == ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    return ((argrt_list_t *)0);
  }
#line 262 "list.arg"
  while (!((((argrt_list_t *)p_list_of_8)->prev == ((argrt_list_t *)0)))) {
    p_list_of_8 = ((argrt_list_t *)p_list_of_8)->prev;
  };
#line 264 "list.arg"
  return p_list_of_8;
}

/** :argrt_list_end <list>: -> list **/
#line 267 "list.arg"
argrt_list_t * argrt_list_end(argrt_list_t * p_list_of_9)
{
#line 268 "list.arg"
  if ((p_list_of_9 == ((argrt_list_t *)0))) {
#line 579 "./std.argl"
    return ((argrt_list_t *)0);
  }
#line 269 "list.arg"
  while (!((((argrt_list_t *)p_list_of_9)->next == ((argrt_list_t *)0)))) {
    p_list_of_9 = ((argrt_list_t *)p_list_of_9)->next;
  };
#line 271 "list.arg"
  return p_list_of_9;
}

/** :argrt_list_count <list>: -> nat **/
#line 274 "list.arg"
unsigned int argrt_list_count(argrt_list_t * p_list_of_10)
{
#line 275 "list.arg"
  unsigned int count = 0;

#line 276 "list.arg"
  while (!((p_list_of_10 == ((argrt_list_t *)0)))) {
    (count)++;
    p_list_of_10 = ((argrt_list_t *)p_list_of_10)->next;
  };
#line 279 "list.arg"
  return count;
}

/** :argrt_list_seek <list> <int offset>: -> list **/
#line 282 "list.arg"
argrt_list_t * argrt_list_seek(argrt_list_t * p_list_of_11, int offset)
{
#line 283 "list.arg"
  while (((offset < 0) && (p_list_of_11 != ((argrt_list_t *)0)))) {
    (offset)++;
    p_list_of_11 = ((argrt_list_t *)p_list_of_11)->prev;
  };
#line 286 "list.arg"
  while (((offset > 0) && (p_list_of_11 != ((argrt_list_t *)0)))) {
    (offset)--;
    p_list_of_11 = ((argrt_list_t *)p_list_of_11)->next;
  };
#line 289 "list.arg"
  return p_list_of_11;
}

/** :argrt_list_shadow <list>: -> list **/
#line 292 "list.arg"
argrt_list_t * argrt_list_shadow(argrt_list_t * p_list_of_12)
{
#line 293 "list.arg"
  argrt_list_t * shadow = ((argrt_list_t *)0);
  argrt_list_t * start = ((argrt_list_t *)0);

#line 295 "list.arg"
  while ((p_list_of_12 != ((argrt_list_t *)0))) {
    argrt_list_append(&shadow, argrt_list_new(((void *)((long)*((void * *)&((argrt_list_t *)p_list_of_12)->data.any))), ((void (*)())NULL)));
    if ((start == ((argrt_list_t *)0))) {
      start = shadow;
    }
#line 299 "list.arg"
    p_list_of_12 = ((argrt_list_t *)p_list_of_12)->next;
  };
#line 300 "list.arg"
  return start;
}

