// generated by: arc -xuNP -A ./../argrt -M -o std_extdef.c -H std_extdef.h -m std_extdef.argl.tmp std_extdef.arg 
#include "std_extdef.h"

/** :<match m> has a variable return type ?: -> bool **/
static unsigned char has_a_variable_return_type(argile_match_t *);
/** :check params of <list of (argile syntax) syn>: -> bool **/
static unsigned char check_params_of(argrt_list_t *);
/** :make defs of params in <list of (argile syntax) syn> <argile code scope>: -> nothing **/
static void make_defs_of_params_in(argrt_list_t *, argile_code_t *);
/** :<def>: -> nothing **/
static void argile_def_2(argile_def_t *);

char( argmod_extdef_doc[]) = {"Make an external definition with a C identifier (word), a syntax and\noptionnally a type.\nIf the binding option `func' is specified, an external function is\ndefined, if not, an exnternal variable is defined.\nIf the binding option `Cmacro' is specified, an external C macro is\ndefined instead of a function or variable.\nThis is used by modules interfaces (*.argl).\nSyntax requirements:\n  :<word> <syntax> (<type>):\n"};
int argmod_extdef_defmaker = 1;

/** :argmod_extdef_reject <call>: -> int **/
int argmod_extdef_reject(argile_call_t * p_argile_call)
{
  argile_match_t * m = ((argile_match_t *)0);
  argrt_list_t * syn = ((argrt_list_t *)0);
  argile_type_t type;
  char * ident = (char *)0;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  unsigned char is_Cmacro;
  unsigned char is_func;
  unsigned char is_var;

  type = (argile_type_t)ARGILE_TYPE_NOTHING;
  sh = argile_shovel_new(p_argile_call);
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0))) {
    type = argile_match_eval_type(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    ident = argile_match_eval_word(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
  }
  argile_shovel_del(sh);
  is_Cmacro = (argile_def_has_option((p_argile_call)->def, "Cmacro"));
  is_func = (argile_def_has_option((p_argile_call)->def, "func"));
  is_var = (!(is_func) && !(is_Cmacro));
  if ((syn == ((argrt_list_t *)0))) {
    return argile_call_add_reject(p_argile_call, "std/extdef: ""missing syntax");
  }
  if ((ident == (char *)0)) {
    return argile_call_add_reject(p_argile_call, "std/extdef: ""missing identifier");
  }
  if (((type == (argile_type_t)ARGILE_TYPE_NOTHING) && is_var)) {
    return argile_call_add_reject(p_argile_call, "std/extdef: ""can't define a variable with type nothing");
  }
  return 0;
}

/** :argmod_extdef_compile <call>: -> nothing **/
void argmod_extdef_compile(argile_call_t * p_argile_call_2)
{
  argile_match_t * m = ((argile_match_t *)0);
  argrt_list_t * syn = ((argrt_list_t *)0);
  argile_type_t type;
  char * ident = (char *)0;
  unsigned char is_Cmacro;
  unsigned char is_func;
  unsigned char is_var;
  unsigned char has_variable_type;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_def_t * def = ((argile_def_t *)0);
  unsigned int id = 0;

  type = (argile_type_t)ARGILE_TYPE_NOTHING;
  is_Cmacro = (argile_def_has_option((p_argile_call_2)->def, "Cmacro"));
  is_func = (argile_def_has_option((p_argile_call_2)->def, "func"));
  is_var = (!(is_func) && !(is_Cmacro));
  has_variable_type = 0;
  sh = argile_shovel_new(p_argile_call_2);
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0))) {
    type = argile_match_eval_type(m);
    has_variable_type = has_a_variable_return_type(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    ident = argile_match_eval_word(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
  }
  argile_shovel_del(sh);
  if (((syn == ((argrt_list_t *)0)) || (ident == (char *)0))) {
    return;
  }
  if (is_func) {
    def = argile_def_new(syn, 0, type, p_argile_call_2, ARGILE_DEF_FUNC, NULL);
  }
  else if (is_var) {
    def = argile_def_new(syn, 0, (((((((int)type) >> 30) & 1))) ? (type) : ((((int)(((int)type) & ((1 << 30) - 1))) | (1 << 31)))), p_argile_call_2, ARGILE_DEF_VAR, argile_var_new(type, ((argile_match_t *)0)));
  }
  else if (is_Cmacro) {
    argile_code_t * body = ((argile_code_t *)0);

    body = argile_code_new((p_argile_call_2)->scope, ((argrt_list_t *)0));
    (body)->owner = p_argile_call_2;
    (body)->cmacro = 1;
    (body)->type = type;
    (body)->has_params = check_params_of(syn);
    def = argile_def_new(syn, 0, type, p_argile_call_2, ARGILE_DEF_FUNC, body);
    (body)->func = def;
    (def)->ext = 1;
    (def)->vartype = has_variable_type;
    make_defs_of_params_in(syn, body);
    (p_argile_call_2)->del = (void *)&argile_def_2;
  }
  argile_code_def((p_argile_call_2)->scope, def, 1);
  (p_argile_call_2)->data = def;
  (def)->genid = ARGRT_strdup(ident);
  id = (argile_hash(ident) % 1024);
  if ((argrt_list_search(((argile).ids)[id], ident, (void *)&argile_streq) == ((argrt_list_t *)0))) {
    argrt_list_prepend(&((argile).ids)[id], argrt_list_new(((void *)((long)ident)), ((argile_deleter_t)0)));
  }
}

/** :<match m> has a variable return type ?: -> bool **/
static unsigned char has_a_variable_return_type(argile_match_t * m)
{
  if ((m == ((argile_match_t *)0))) {
    return 0;
  }
  if (((m)->type == ARGILE_MATCH_SUBCALL)) {
    argile_call_t * sub = ((argile_call_t *)0);
    argrt_list_t * lm;

    sub = ((m)->value).call;
    if ((((sub)->def != ((argile_def_t *)0)) && (((sub)->def)->locall || ((sub)->def)->vartype))) {
      return 1;
    }
    lm = (sub)->match;
    for (; (lm); lm = ((argrt_list_t *)lm)->next) {
      if (has_a_variable_return_type(*((argile_match_t * *)&((argrt_list_t *)lm)->data))) {
        return 1;
      }
    };
  }
  return 0;
}

/** :check params of <list of (argile syntax) syn>: -> bool **/
static unsigned char check_params_of(argrt_list_t * syn)
{
  for (; (syn); syn = ((argrt_list_t *)syn)->next) {
    argile_syntax_t * s = ((argile_syntax_t *)0);

    s = *((argile_syntax_t * *)&((argrt_list_t *)syn)->data);
    switch ((s)->type) {
      case ARGILE_SYN_PARAM: {
        return 1;
      } break;
      case ARGILE_SYN_OPTION: {
        if (check_params_of(((s)->value).syn_option)) {
          return 1;
        }
      } break;
      case ARGILE_SYN_ENUM: {
        argrt_list_t * lenm;

        lenm = ((s)->value).syn_enum;
        for (; (lenm); lenm = ((argrt_list_t *)lenm)->next) {
          if (check_params_of(*((argrt_list_t * *)&((argrt_list_t *)lenm)->data))) {
            return 1;
          }
        };
      } break;
      case ARGILE_SYN_LIST: {
        if (check_params_of((((s)->value).syn_list)->sub)) {
          return 1;
        }
      } break;
      default: {} break;
    };
  };
  return 0;
}

/** :make defs of params in <list of (argile syntax) syn> <argile code scope>: -> nothing **/
static void make_defs_of_params_in(argrt_list_t * syn_2, argile_code_t * scope)
{
  for (; (syn_2); syn_2 = ((argrt_list_t *)syn_2)->next) {
    argile_syntax_t * s = ((argile_syntax_t *)0);

    s = *((argile_syntax_t * *)&((argrt_list_t *)syn_2)->data);
    switch ((s)->type) {
      case ARGILE_SYN_PARAM: {
        argile_syn_param_t * sp = ((argile_syn_param_t *)0);
        argile_def_t * d = ((argile_def_t *)0);

        sp = ((s)->value).syn_param;
        d = argile_def_new(((argrt_list_t *)0), 0, (((((((int)(sp)->type) >> 30) & 1))) ? ((sp)->type) : ((((int)(((int)(sp)->type) & ((1 << 30) - 1))) | (1 << 31)))), (argile_call_t *)0, ARGILE_DEF_VAR, argile_var_new((sp)->type, ((argile_match_t *)0)));
        (d)->param = sp;
        if ((((sp)->def != ((argile_def_t *)0)) && ((sp)->def)->locall)) {
          argile_def_reuse_var((sp)->def, ((d)->dval).var);
        }
        (sp)->def = d;
        argile_code_def(scope, d, 1);
      } break;
      case ARGILE_SYN_OPTION: {
        make_defs_of_params_in(((s)->value).syn_option, scope);
      } break;
      case ARGILE_SYN_ENUM: {
        argrt_list_t * le;

        le = ((s)->value).syn_enum;
        for (; (le); le = ((argrt_list_t *)le)->next) {
          make_defs_of_params_in(*((argrt_list_t * *)&((argrt_list_t *)le)->data), scope);
        };
      } break;
      case ARGILE_SYN_LIST: {
        make_defs_of_params_in((((s)->value).syn_list)->sub, scope);
      } break;
      default: {} break;
    };
  };
}

/** :<def>: -> nothing **/
static void argile_def_2(argile_def_t * p_argile_def)
{
  argile_code_del(((p_argile_def)->dval).code);
  ((p_argile_def)->dval).code = ((argile_code_t *)0);
}

