// generated by: arc -xuNP -A ./../argrt -M -o std_extern.c -H std_extern.h -m std_extern.argl.tmp std_extern.arg 
#include "std_extern.h"

char( argmod_extern_doc[]) = {"Make an external definition with a C identifier (word), a syntax and\noptionnally a type. If a syntax is specified, a function is defined,\nif not, a variable is defined with the identifier as syntax.\nIf no identifier is specified, the syntax must begin by a word which\nwill be used as identifier.\nIf the binding option `nodecl' is specified, no declaration will be\ngenerated.\nSyntax requirements:\n  :<word> <syntax> (<type>):\n  :{<word>|<syntax>} (<type>):\n"};
int argmod_extern_defmaker = 1;

/** :argmod_extern_reject <call>: -> int **/
int argmod_extern_reject(argile_call_t * p_argile_call)
{
  argile_match_t * m = ((argile_match_t *)0);
  argrt_list_t * syn = ((argrt_list_t *)0);
  argile_type_t type;
  char * ident = (char *)0;
  argile_shovel_t * sh = ((argile_shovel_t *)0);

  type = (argile_type_t)ARGILE_TYPE_NOTHING;
  sh = argile_shovel_new(p_argile_call);
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0))) {
    type = argile_match_eval_type(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    ident = argile_match_eval_word(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
  }
  argile_shovel_del(sh);
  if (((syn == ((argrt_list_t *)0)) && (ident == (char *)0))) {
    return argile_call_add_reject(p_argile_call, "std/extern: ""no identifier and no syntax were given");
  }
  if (((syn == ((argrt_list_t *)0)) && (type == (argile_type_t)ARGILE_TYPE_NOTHING))) {
    return argile_call_add_reject(p_argile_call, "std/extern: ""can't define a variable with type nothing");
  }
  return 0;
}

/** :argmod_extern_compile <call>: -> nothing **/
void argmod_extern_compile(argile_call_t * p_argile_call_2)
{
  argile_match_t * m = ((argile_match_t *)0);
  argrt_list_t * syn = ((argrt_list_t *)0);
  argile_type_t type;
  char * ident = (char *)0;
  unsigned char nodecl;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_def_t * def = ((argile_def_t *)0);
  unsigned int id = 0;

  type = (argile_type_t)ARGILE_TYPE_NOTHING;
  nodecl = (argile_def_has_option((p_argile_call_2)->def, "nodecl"));
  sh = argile_shovel_new(p_argile_call_2);
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0))) {
    type = argile_match_eval_type(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0))) {
    ident = argile_match_eval_word(m);
  }
  if ((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0))) {
    syn = argile_match_eval_syntax(m);
  }
  argile_shovel_del(sh);
  if (((syn == ((argrt_list_t *)0)) && (ident == (char *)0))) {
    return;
  }
  if ((syn == ((argrt_list_t *)0))) {
    if ((type == (argile_type_t)ARGILE_TYPE_NOTHING)) {
      return;
    }
    syn = argrt_list_new(((void *)((long)argile_syntax_new(ARGILE_SYN_WORD, ARGRT_strdup(ident)))), (void *)&argile_syntax_del);
    def = argile_def_new(syn, 1, (((((((int)type) >> 30) & 1))) ? (type) : ((((int)(((int)type) & ((1 << 30) - 1))) | (1 << 31)))), p_argile_call_2, ARGILE_DEF_VAR, argile_var_new(type, ((argile_match_t *)0)));
  }
  else {
    if ((ident == (char *)0)) {
      argile_syntax_t * s = ((argile_syntax_t *)0);

      s = *((argile_syntax_t * *)&((argrt_list_t *)syn)->data);
      if (((s)->type != ARGILE_SYN_WORD)) {
        argile_die_at(p_argile_call_2, "std/extern: ""syntax must start by a word");
        return;
      }
      ident = ((s)->value).syn_word;
    }
    def = argile_def_new(syn, 0, type, p_argile_call_2, ARGILE_DEF_FUNC, NULL);
  }
  argile_code_def((p_argile_call_2)->scope, def, 1);
  (p_argile_call_2)->data = def;
  (def)->ext = 1;
  (def)->nodecl = nodecl;
  (def)->genid = ARGRT_strdup(ident);
  id = (argile_hash(ident) % 1024);
  if ((argrt_list_search(((argile).ids)[id], ident, (void *)&argile_streq) == ((argrt_list_t *)0))) {
    argrt_list_prepend(&((argile).ids)[id], argrt_list_new(((void *)((long)ident)), ((argile_deleter_t)0)));
  }
}

