// generated by: arc -xuNP -A ./../argrt -M -o std_return.c -H std_return.h -m std_return.argl.tmp std_return.arg 
#include "std_return.h"

char( argmod_return_doc[]) = "Return from current function, with an optional return value.\nIf it is called from an anonymous function, it will also\nproduce a call to va_end().\nSyntax requirements:\n  :(<any>):\n  : <any&>:\n";

/** :argmod_return_gettype <call>: -> argile type **/
argile_type_t argmod_return_gettype(argile_call_t * p_argile_call)
{
  argile_code_t * body = ((argile_code_t *)0);
  unsigned char at_last;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_match_t * m = ((argile_match_t *)0);

  body = argile_util_getfuncbody((p_argile_call)->scope);
  at_last = 0;
  if ((((p_argile_call)->owner == ((argile_call_t *)0)) && (body != ((argile_code_t *)0)))) {
    argrt_list_t * last;

    last = argrt_list_end((body)->calls);
    if (((last) && (p_argile_call == *((argile_call_t * *)&((argrt_list_t *)last)->data)))) {
      if (((body)->type != (argile_type_t)ARGILE_TYPE_NOTHING)) {
        at_last = 1;
      }
    }
  }
  if (!(at_last)) {
    return (argile_type_t)ARGILE_TYPE_NOTHING;
  }
  sh = argile_shovel_new(p_argile_call);
  m = argile_shovel_diganymatch(sh, 1, (char *)0);
  argile_shovel_del(sh);
  if ((m == ((argile_match_t *)0))) {
    return (argile_type_t)ARGILE_TYPE_NOTHING;
  }
  if (((m)->type == ARGILE_MATCH_SUBCALL)) {
    argile_call_t * sub = ((argile_call_t *)0);
    argile_type_t ctx;
    argile_type_t t;

    sub = ((m)->value).call;
    ctx = (sub)->context;
    (sub)->context = (p_argile_call)->context;
    t = argile_call_get_type(sub);
    (sub)->context = ctx;
    if (((((((int)t) >> 31) & 1)) && !((((((int)(p_argile_call)->context) >> 31) & 1))))) {
      return (((int)t) & ~((1 << 31)));
    }
    return t;
  }
  if (((m)->type == ARGILE_MATCH_CONS)) {
    (argile_cons_match_type(((m)->value).cons, (p_argile_call)->context));
    return (((m)->value).cons)->type;
  }
  return ARGILE_TYPE_NOTHING;
}

/** :argmod_return_reject <call>: -> int **/
int argmod_return_reject(argile_call_t * p_argile_call_2)
{
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_match_t * m = ((argile_match_t *)0);
  argile_type_t ftype;
  argile_code_t * body = ((argile_code_t *)0);

  sh = argile_shovel_new(p_argile_call_2);
  m = argile_shovel_diganymatch(sh, 1, (char *)0);
  argile_shovel_del(sh);
  body = argile_util_getfuncbody((p_argile_call_2)->scope);
  if ((body)) {
    ftype = (body)->type;
  }
  else if ((argile).do_main) {
    ftype = (argile_type_t)ARGILE_TYPE_INTEGER;
  }
  else {
    return 0;
  }
  if ((m == ((argile_match_t *)0))) {
    if ((ftype != (argile_type_t)ARGILE_TYPE_NOTHING)) {
      return argile_call_add_reject(p_argile_call_2, "std/return: ""need a value to return for this function");
    }
    return 0;
  }
  if ((ftype == (argile_type_t)ARGILE_TYPE_NOTHING)) {
    return argile_call_add_reject(p_argile_call_2, "std/return: ""returning a value in a function returning nothing");
  }
  if (!((argile_match_type(m, ftype)))) {
    argile_buff_t b = ((argile_buff_t){0});
    argile_type_t rtype;

    argile_buff_puts(&b, "std/return: """);
    argile_buff_puts(&b, "returning \"");
    rtype = argile_match_get_type(m);
    argile_typename(rtype, &b, (p_argile_call_2)->scope);
    argile_buff_puts(&b, "\" in a function returning \"");
    argile_typename(ftype, &b, (p_argile_call_2)->scope);
    argile_buff_puts(&b, "\"");
    argile_buff_putc(&b, '\0');
    argile_call_add_reject(p_argile_call_2, (b).ptr);
    ARGRT_free((b).ptr);
    return 1;
  }
  return 0;
}

/** :argmod_return_gencode <call>: -> nothing **/
void argmod_return_gencode(argile_call_t * p_argile_call_3)
{
  unsigned char returned;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_code_t * body = ((argile_code_t *)0);
  argile_match_t * m = ((argile_match_t *)0);

  returned = 0;
  if ((((p_argile_call_3)->owner == ((argile_call_t *)0)) && !((((p_argile_call_3)->scope)->macro || ((p_argile_call_3)->scope)->cmacro)))) {
    argrt_list_t * last;

    last = argrt_list_end(((p_argile_call_3)->scope)->calls);
    if (((last) && (p_argile_call_3 == *((argile_call_t * *)&((argrt_list_t *)last)->data)))) {
      if ((((p_argile_call_3)->scope)->type != (argile_type_t)ARGILE_TYPE_NOTHING)) {
        returned = (argile_type_match(((p_argile_call_3)->scope)->type, argile_call_get_type(p_argile_call_3)));
      }
    }
  }
  sh = argile_shovel_new(p_argile_call_3);
  body = argile_util_getfuncbody((p_argile_call_3)->scope);
  if (!(returned)) {
    if ((((body) && ((body)->anon)) && !((body)->caster))) {
      argile_printf("va_end(%s);\n", "anon_va");
      argile_indent();
    }
    argile_puts("return");
  }
  m = argile_shovel_diganymatch(sh, 1, (char *)0);
  if ((m)) {
    if (!(returned)) {
      argile_puts(" ");
      if (((body) && ((body)->type == (argile_type_t)ARGILE_TYPE_ANYTHING))) {
        argile_puts("(void *)");
      }
    }
    if ((((body) && ((body)->anon)) && !((body)->caster))) {
      argile_puts("(");
      argile_type_gen_prefix((body)->type);
      argile_type_gen_suffix((body)->type);
      argile_puts(")");
    }
    argile_match_gencode(m);
  }
  argile_shovel_del(sh);
}

