// generated by: arc -xuNP -A ./../argrt -M -o std_union.c -H std_union.h -m std_union.argl.tmp std_union.arg 
#include "std_union.h"

/** :add_type <(list of (field)) & head> <argile type type> <argile type in_type> <shovel sh> <call>: -> nothing **/
static void add_type(argrt_list_t * *, argile_type_t, argile_type_t, argile_shovel_t *, argile_call_t *);

int argmod_union_defmaker = 1;
argile_type_t argmod_union_type = ARGILE_TYPE_TYPE;
char( argmod_union_doc[]) = "Define a union type with a word or syntax, and a list of types.\nIf the bind option `silent' is specified, a union will never\ngenerate a field name when called (e.g. `foobar' instead of\n`(foobar).u_int').\nSyntax requirements:\n  :{<syntax>|<word>} [<type>...]:\n";

/** :argmod_union_evaltype <call>: -> argile type **/
argile_type_t argmod_union_evaltype(argile_call_t * p_argile_call)
{
  argile_type_t t;

  if (((p_argile_call)->data != NULL)) {
    return ((argile_type_t)((long)(p_argile_call)->data));
  }
  t = argile_type_new();
  (p_argile_call)->data = ((void *)((long)t));
  (p_argile_call)->keep_data = 1;
  argile_type_set_info(t, ARGILE_TYPE_KIND_UNION);
  return t;
}

/** :argmod_union_compile <call>: -> nothing **/
void argmod_union_compile(argile_call_t * p_argile_call_2)
{
  argrt_list_t * syn = ((argrt_list_t *)0);
  unsigned char del_syn;
  argile_shovel_t * sh = ((argile_shovel_t *)0);
  argile_match_t * m = ((argile_match_t *)0);

  del_syn = 0;
  sh = argile_shovel_new(p_argile_call_2);
  if (((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_SYNTAX, (char *)0)) && ((m)->type == ARGILE_MATCH_CONS))) {
    syn = ((((m)->value).cons)->cvalue).syntax;
  }
  else if (((m = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_WORD, (char *)0)) && ((m)->type == ARGILE_MATCH_WORD))) {
    char * word = "";

    word = ARGRT_strdup(((m)->value).word);
    syn = argrt_list_new(((void *)((long)argile_syntax_new(ARGILE_SYN_WORD, word))), (void *)&argile_syntax_del);
    del_syn = 1;
  }
  if ((syn)) {
    argile_type_t type;
    argile_type_info_t * info = ((argile_type_info_t *)0);

    type = argmod_union_evaltype(p_argile_call_2);
    argile_code_def((p_argile_call_2)->scope, argile_def_new(syn, ((int)del_syn), (argile_type_t)ARGILE_TYPE_TYPE, p_argile_call_2, ARGILE_DEF_TYPE, ((void *)((long)type))), 1);
    info = argile_type_set_info(type, ARGILE_TYPE_KIND_UNION);
    (((info)->tval).t_union).silent = (argile_def_has_option((p_argile_call_2)->def, "silent"));
    while ((argile_shovel_diglist(sh, 1) != 0)) {
      argile_match_t * match = ((argile_match_t *)0);

      match = argile_shovel_digmatch(sh, 1, (argile_type_t)ARGILE_TYPE_TYPE, (char *)0);
      if ((match)) {
        add_type(&(((info)->tval).t_union).variants, argile_match_eval_type(match), type, sh, p_argile_call_2);
      }
      argile_shovel_shiftlist(sh, 1, 1);
    };
  }
  argile_shovel_del(sh);
}

/** :add_type <(list of (field)) & head> <argile type type> <argile type in_type> <shovel sh> <call>: -> nothing **/
static void add_type(argrt_list_t * * head, argile_type_t type, argile_type_t in_type, argile_shovel_t * sh, argile_call_t * p_argile_call_3)
{
  argile_type_info_t * ti = ((argile_type_info_t *)0);
  argrt_list_t * lt;
  argile_field_t * field = ((argile_field_t *)0);

  ti = argile_type_get_info(type);
  if (((((((int)type) >> 30) & 1)) && ((NULL == ti) || ((ti)->ttype != ARGILE_TYPE_KIND_CLASS)))) {
    type = (((int)type) & ~((1 << 30)));
  }
  lt = *head;
  for (; (lt); lt = ((argrt_list_t *)lt)->next) {
    if ((type == (*((argile_field_t * *)&((argrt_list_t *)lt)->data))->type)) {
      return;
    }
  };
  field = argile_field_new(type, in_type, (char *)0);
  argrt_list_prepend(head, argrt_list_new(((void *)((long)field)), (void *)&argile_field_del));
}

