// generated by: arc -xuNP -A ./../argrt -M -o syntax.c -H syntax.h -m syntax.argl.tmp syntax.arg 
#ifndef _syntax_HEADER__device_2052_inode_4268339_
#define _syntax_HEADER__device_2052_inode_4268339_

typedef struct argile_syntax_t_s argile_syntax_t;
typedef struct argile_syn_list_t_s argile_syn_list_t;
typedef struct argile_syn_param_t_s argile_syn_param_t;
typedef enum   argile_syn_type_t_e argile_syn_type_t;
typedef union  argile_syn_val_t_u argile_syn_val_t;

#include "./../argrt/std.h"
#include "./../argrt/array.h"
#include "./buff.h"
#include "./list.h"
#include "./code.h"
#include "./call.h"
#include "./match.h"
#include "./type.h"
#include "./def.h"
#include "./fnc.h"
#include "./argilectx.h"
#include "./inout.h"
#include "./cons.h"
#include "./var.h"

enum   argile_syn_type_t_e {
  ARGILE_SYN_WORD,
  ARGILE_SYN_OP,
  ARGILE_SYN_PARAM,
  ARGILE_SYN_OPTION,
  ARGILE_SYN_ENUM,
  ARGILE_SYN_LIST
};

union  argile_syn_val_t_u {
  void * data;
  char * syn_word;
  char * syn_op;
  argile_syn_param_t * syn_param;
  argrt_list_t * syn_option;
  argrt_list_t * syn_enum;
  argile_syn_list_t * syn_list;
};

struct argile_syntax_t_s {
  argile_syn_type_t type;
  argile_syn_val_t value;
  char * genid;
};

struct argile_syn_list_t_s {
  argrt_list_t * sub;
  int min;
  int max;
  unsigned char pseudoempty : 1;
};

struct argile_syn_param_t_s {
  argrt_list_t * match;
  argile_match_t * init;
  argile_type_t type;
  argile_def_t * def;
  argile_call_t * tcall;
  char * name;
  char * genid;
  unsigned char pseudo : 1;
  unsigned char in_list : 1;
  unsigned char comp : 1;
  int order;
};

/** :argile_syntax_new <syn type t> <any data>: -> argile syntax **/
argile_syntax_t * argile_syntax_new(argile_syn_type_t, void *);
/** :argile_syntax_del <argile syntax s>: -> nothing **/
void argile_syntax_del(argile_syntax_t *);
/** :argile_syntax_string <list of (argile syntax) s> <buff buf>: -> nothing **/
void argile_syntax_string(argrt_list_t *, argile_buff_t *);
/** :argile_syntax_gen_id <list of (argile syntax) s> <call maker> <buff buf>: -> nothing **/
void argile_syntax_gen_id(argrt_list_t *, argile_call_t *, argile_buff_t *);
/** :argile_syntax_gen_params <list of (argile syntax) syn> <int names> <(int) & param>: -> nothing **/
void argile_syntax_gen_params(argrt_list_t *, int, int *);
/** :argile_syntax_gen_options <list of (argile syntax) s> <argile code body> <(int) & param>: -> nothing **/
void argile_syntax_gen_options(argrt_list_t *, argile_code_t *, int *);
/** :argile_syntax_gen_enums <list of (argile syntax) s> <argile code body> <(int) & param>: -> nothing **/
void argile_syntax_gen_enums(argrt_list_t *, argile_code_t *, int *);
/** :argile_syntax_gen_lists <list of (argile syntax) s> <argile code body> <(int) & param>: -> nothing **/
void argile_syntax_gen_lists(argrt_list_t *, argile_code_t *, int *);
/** :argile_syntax_gen_call <list of (argile syntax) s> <buff buf>: -> nothing **/
void argile_syntax_gen_call(argrt_list_t *, argile_buff_t *);
/** :argile_syntax_check_format <text str>: -> int **/
int argile_syntax_check_format(char *);
/** :argile_syntax_parse <text str>: -> list of (argile syntax) **/
argrt_list_t * argile_syntax_parse(char *);
/** :argile_syn_param_new <list of (match) call> <match init>: -> (argile) syn param **/
argile_syn_param_t * argile_syn_param_new(argrt_list_t *, argile_match_t *);
/** :argile_syn_param_del <syn param s>: -> nothing **/
void argile_syn_param_del(argile_syn_param_t *);
/** :argile_syn_param_eval_type <syn param sp> <call>: -> argile type **/
argile_type_t argile_syn_param_eval_type(argile_syn_param_t *, argile_call_t *);
/** :argile_syn_param_string <syn param s> <buff buf>: -> nothing **/
void argile_syn_param_string(argile_syn_param_t *, argile_buff_t *);
/** :argile_syn_param_gen_id <syn param s>: -> text **/
char * argile_syn_param_gen_id(argile_syn_param_t *);
/** :argile_syn_list_new <list of (argile syntax) sub> <int min> <int max>: -> (argile) syn list **/
argile_syn_list_t * argile_syn_list_new(argrt_list_t *, int, int);
/** :argile_syn_list_del <syn list s>: -> nothing **/
void argile_syn_list_del(argile_syn_list_t *);
/** :argile_syn_list_string <syn list s> <buff buf>: -> nothing **/
void argile_syn_list_string(argile_syn_list_t *, argile_buff_t *);
/** :argile_syntax_compile_params <list of (argile syntax) syntax> <argile code scope> <call>: -> int **/
int argile_syntax_compile_params(argrt_list_t *, argile_code_t *, argile_call_t *);
/** :argile_syntax_is_terminal <list of (argile syntax) syn>: -> int **/
int argile_syntax_is_terminal(argrt_list_t *);
/** :argile_syntax_match <list of (argile syntax) syntax> <list of (argile syntax) syn_pattern>: -> int **/
int argile_syntax_match(argrt_list_t *, argrt_list_t *);
/** :argile_syntax_module_call <list of (argile syntax) syntax> <buff type_bp> <text word_p> <list of (argile syntax) syntax_p> <buff out>: -> nothing **/
void argile_syntax_module_call(argrt_list_t *, argile_buff_t *, char *, argrt_list_t *, argile_buff_t *);
/** :argile_syntax_find_autoparams <list of (argile syntax) syn>: -> bool **/
unsigned char argile_syntax_find_autoparams(argrt_list_t *);

#endif /* _syntax_HEADER__device_2052_inode_4268339_ */
